$title	Merge State-Level Data to Form a National Dataset

*	Alternative reference to the set of regions:

$include defines\528.set

SET	hh	Private (household) institutions /
		HHL "Households LT5k   (10001)"
		HH5 "Households 5-10k  (10002)"
		HH10 "Households 10-15k (10003)"
		HH15 "Households 15-20k (10004)"
		HH20 "Households 20-30k (10005)"
		HH30 "Households 30-40k (10006)"
		HH40 "Households 40-50k (10007)"
		HH50 "Households 50-70k (10008)"
		HH70 "Households 70k+   (10009)"/,

	trd  Trade partners /
		FTRD "Foreign Trade (25001)"
		DTRD "Domestic Trade (28001)" /,

	pub	Public (government) institutions /
		FND "Federal Government NonDefense (11001)"
		FDF "Federal Government Defense (11002)"
		FIN "Federal Government Investment (11003)"
		SLN "State Local Govt NonEducation (12001)"
		SLE "State Local Govt Education (12002)"
		SIN "State Local Govt Investment (12003)" /;

alias (s,g);

parameter

*	Arrays which hold merged data:

	x0(r,s,trd)	Exports by market
	m0(r,g,trd)	Imports from domestic and foreign sources
	id0(r,g,s)	Intermediate demand
	kd0(r,s)	Capital return
	ld0(r,s)	Labor demand
	bt0(r,s)	Business taxes
	fica(r)		Labor tax rate (social security)
	i0(r,g)		Investment demand by commodity
	g0(r,g,pub)	Public demand by commodity
	le0(r,hh)	Labor endowment
	ke0(r,hh)	Capital endowment
	cd0(r,g,hh)	Consumer demand
	invd0(r,hh)	Investment

*	Local arrays used for reading individual regional data from the GDX files:b
	x0_(s,trd)	Exports by market
	m0_(g,trd)	Imports from domestic and foreign sources
	id0_(g,s)	Intermediate demand
	kd0_(s)		Capital return
	ld0_(s)		Labor demand
	bt0_(s)		Business taxes
	i0_(g)		Investment demand by commodity
	g0_(g,pub)	Public demand by commodity
	le0_(hh)	Labor endowment
	ke0_(hh)	Capital endowment
	cd0_(g,hh)	Consumer demand
	invd0_(hh)	Investment;

scalar	fica_		Labor tax rate (social security);

$if not exist data\CO.gdx $call 'gmsunzip data\states *.gdx -d data'
$offlisting
$batinclude readparam x0 "s,trd"  
$batinclude readparam m0 "g,trd" 
$batinclude readparam id0 "g,s" 
$batinclude readparam kd0 s 
$batinclude readparam ld0 s 
$batinclude readparam bt0 s 
$batinclude readparam fica "" 
$batinclude readparam i0 g 
$batinclude readparam g0 "g,pub" 
$batinclude readparam le0 hh 
$batinclude readparam ke0 hh 
$batinclude readparam cd0 "g,hh" 
$batinclude readparam invd0 hh 
execute_unload 'data\528',r,s,x0,m0,id0,kd0,ld0,bt0,fica,i0,g0,le0,ke0,cd0,invd0;
