$title  Read a single state file

$if not set year    $set year 98	
$if not set ds $set ds co

SET R Rows and columns in the SAM /

	1*528		Industries,

	3001*3528	Commodities,

	5001 Employee Compensation  				    
	6001 Proprietary Income	    				    
	7001 Other Property Income  				    
	8001 Indirect Business Taxes				    

	10001*10009 Households

	11001 Federal Government NonDefense
	11002 Federal Government Defense
	11003 Federal Government Investment
	12001 State Local Govt NonEducation 
	12002 State Local Govt Education
	12003 State Local Govt Investment
	13001 Enterprises (Corporations)
	14001 Gross Private Fixed Investment (Capital)
	14002 Inventory Sales - Deletions

	25001 Foreign trade
	28001 Domestic Trade/;

set T  Account codes  /
	3001*3528	Commodities,

	15001		"Corporate Profits with IVA"
	15002		"Emp Comp (Wages/Salary w/o Soc Sec)"
	15003		"Employee Comp (Other Labor Income)"
	15004		"Proprietors Inc (w/o Soc Sec & CCA)"
	15005		"Rent with Capital Consumption Adj"
	15006		"Business Transfers"
	15007		"Dividends"
	15008		"Interest (Net-from Industries)"
	15009		"Interest (Gross)"
	15010		"Transfers"
	15011		"Surplus or Deficit"
	15012		"Savings (Surplus)           not use"
	15013		"Wage Accruals Less Surplus"
	15014		"Social Ins Tax- Employee Contribution"
	15015		"Social Ins Tax- Employer Contribution"
	15016		"Surplus-Subsidy- Govt Enterprises"
	15017		"Indirect Bus Tax: Excise Taxes"
	15018		"Indirect Bus Tax: Custom Duty"
	15019		"Indirect Bus Tax: Fed NonTaxes"
	15020		"Indirect Bus Tax: Sales Tax"
	15021		"Indirect Bus Tax: Property Tax"
	15022		"Indirect Bus Tax: Motor Vehicle Lic"
	15023		"Indirect Bus Tax: Severance Tax"
	15024		"Indirect Bus Tax: Other Taxes"
	15025		"Indirect Bus Tax: S/L NonTaxes"
	15026		"Corporate Profits Tax"
	15027		"Personal Tax: Income Tax"
	15028		"Personal Tax: Estate and Gift Tax"
	15029		"Personal Tax: NonTaxes (Fines- Fees"
	15030		"Personal Tax: Motor Vehicle License"
	15031		"Personal Tax: Property Taxes"
	15032		"Personal Tax: Other Tax (Fish/Hunt)"
	15033		"Capital Consumption Allowance"
	15034		"Retained Profits (Profits w/IVA&CCA"
	15035		"NIPA Statistical Discrepency"
	15036		"Interest (Net-from RoW)"
	15037		"Factor Trade"
	15038		"Adjustment to retained earnings"
	15050		"Commodity Use"
	15051		"Commodity Trade"
	15052		"Commodity Make"
	15053		"Factor Receipts"
	15054		"Foreign Commodity Transshipments"
	15055		"Industry Use"
	15056		"Industry Trade"  /;

alias (r,c);

*	Unzip the data file, read it and then delete it:

$if exist data\%ds%%year%.gms       $goto readdata
$if exist implandata\%ds%%year%.zip $goto unzip

$log "Error -- cannot find implandata\%ds%%year%.zip'
$call pause 'Program will now abort.
$abort "Error -- cannot find implandata\%ds%%year%.zip'

$label unzip
$call 'gmsunzip -j implandata\%ds%%year%'
$label readdata
parameter sam(r,t,c)  Base year social accounts /
$offlisting
$include %ds%%year%.gms
$onlisting
/;
$if exist implandata\%ds%%year%.zip $call 'del %ds%%year%.gms'

*	Scale the data here:

sam(r,t,c)$sam(r,t,c) = sam(r,t,c)/1000;

parameter	rowsum	Row sums
		colsum	Column sums
		check	Balance;

rowsum(r) = sum((c,t), sam(r,t,c));
colsum(c) = sum((r,t), sam(r,t,c));

check(r,"rowsum") = rowsum(r);
check(r,"colsum") = colsum(r);
check(r,"tolerance") = rowsum(r) - colsum(r);
check(r,"tol%")$rowsum(r) = 100 * check(r,"tolerance") / rowsum(r);

set chkcol /rowsum, colsum, tolerance, "tol%"/;
check(r,chkcol)$(abs(check(r,"tol%")) lt 0.01) = 0;
display check;

PARAMETER TRACE(*,*)  Comparison of submatrix trace with full SAM;

SET     S(R) Industries		/1*528/,
        G(R) Commodities	/3001*3528/,
        F(R) Factors		/5001,6001,7001,8001 /
        I(R) Institutions	/10001*10009,11001*11003,12001*12003,13001,14001*14002/
        TRD(R) Trade		/25001   Foreign, 28001  Domestic/;

SET  J Aggregated SAM accounts /

(1*528)

*	The following labels are always used:

EMPL	Employee Compensation (5001)
PROP	Proprietary Income (6001)
OTHP	Other Property Income (7001)
BTAX	Indirect Business Taxes (8001)
HHL     Households LT5k   (10001)
HH5     Households 5-10k  (10002)
HH10    Households 10-15k (10003)
HH15    Households 15-20k (10004)
HH20    Households 20-30k (10005)
HH30    Households 30-40k (10006)
HH40    Households 40-50k (10007)
HH50    Households 50-70k (10008)
HH70    Households 70k+   (10009)
FND	Federal Government NonDefense (11001)
FDF	Federal Government Defense (11002)
FIN     Federal Government Investment (11003)
SLN	State Local Govt NonEducation (12001)
SLE	State Local Govt Education (12002)
SIN     State Local Govt Investment (12003)
ENT	Enterprises (Corporations) (13001)
INV	Gross Private Fixed Investment (Capital) (14001)
STK	Inventory Additions Deletions (14002)

FTRD	Foreign Trade (25001)
DTRD	Domestic Trade (28001) /;

SET MAP(J,*) /

EMPL.5001   Employee Compensation
PROP.6001   Proprietary Income
OTHP.7001   Other Property Income
BTAX.8001   Indirect Business Taxes
HHL.10001   Households LT5k
HH5.10002   Households 5-10k
HH10.10003  Households 10-15k
HH15.10004  Households 15-20k
HH20.10005  Households 20-30k
HH30.10006  Households 30-40k
HH40.10007  Households 40-50k
HH50.10008  Households 50-70k
HH70.10009  Households 70k+
FND.11001   Federal Government NonDefense
FDF.11002   Federal Government Defense
FIN.11003   Federal Government Investment
SLN.12001   State Local Govt NonEducation
SLE.12002   State Local Govt Education
SIN.12003   State Local Govt Investment
ENT.13001   Enterprises (Corporations)
INV.14001   Gross Private Fixed Investment (Capital)
STK.14002   Inventory Additions Deletions

FTRD.25001  Foreign Trade
DTRD.28001  Domestic Trade  /;

ALIAS (J,JJ);

SET IMPLAN(J) /1*528/;
MAP(IMPLAN,IMPLAN) = YES;

*	Add commodities to the mapping in accordance with the industry
*	mapping:

LOOP((S,G)$(ORD(G) EQ ORD(S)),	MAP(J,G) = MAP(J,S););

PARAMETER	ASAM(R,C)	Aggregated SAM,
		ASUM		Sum of nonzeros in the SAM;

ASAM(R,C) = SUM(T, SAM(R,T,C));
ASUM = SUM((R,C), ASAM(R,C));

* 'Checking mapping';

SET     MAPERROR(*)     Identifies rows which are improperly mapped;
MAPERROR(R) = YES$(SUM(J$MAP(J,R), 1) - 1);
ABORT$CARD(MAPERROR) " Type 1 error in mapping -- good not mapped:",MAPERROR;
MAPERROR(J) = YES$(SUM(R$MAP(J,R), 1) EQ 0);
ABORT$CARD(MAPERROR) " Type 2 error in mapping -- target not used:",MAPERROR;

SET SJ(J), GJ(J), FJ(J), IJ(J), TJ(J);

SJ(J) = YES$SUM(S$MAP(J,S),1);
GJ(J) = YES$SUM(G$MAP(J,G),1);
FJ(J) = YES$SUM(F$MAP(J,F),1);
IJ(J) = YES$SUM(I$MAP(J,I),1);
TJ(J) = YES$SUM(TRD$MAP(J,TRD),1);

*       Aggregate submatrices and assign new labels:

PARAMETER
         MAKE(J,JJ)     Domestic industry make matrix
         SEXPRT(J,JJ)   Aggregate industry exports
         USE(J,JJ)      Domestic industry use matrix
         IUSE(J,JJ)     Domestic institutional use matrix
         FD(J,JJ)       Factor input matrix : industry use of factors
         FEXPRT(J,JJ)   Factor exports
         IMAKE(J,JJ)    Domestic institutional make matrix
         FS(J,JJ)       Factor disbursement matrix
         TRNSFER(J,JJ)  Inter-institutional transfers
         IEXPRT(J,JJ)   Institutional exports
         SIMPRT(J,JJ)   Industry imports
         FIMPRT(J,JJ)   Factor imports
         IIMPRT(J,JJ)   Institutional imports
         TRNSHP(J,JJ)   Transhipments
         EXPORT(J,J,*)  Exports by sector - commodity - destination
         IMPORT(*,J,J)  Imports by commodity - sector - source;

ALIAS (I,II), (IJ,IIJ),(TJ,TTJ), (TRD,TTRD);

FILE KCON/CON/; PUT KCON;

set maps(s,j), mapg(g,j), mapi(i,j), mapf(f,j), mapt(trd,j), mapii(i,j), maptt(trd,j);
maps(s,sj) = map(sj,s);
mapg(g,gj) = map(gj,g);
mapi(i,ij) = map(ij,i);
mapf(f,fj) = map(fj,f);
mapt(trd,tj) = map(tj,trd);
maptt(trd,tj) = map(tj,trd);
mapii(i,ij) = mapi(i,ij);
display maps, mapg, s, sj, g, gj;


PUTCLOSE //,'Aggregating MAKE'/;
$batinclude mapn asam make maps mapg
TRACE("MAKE","SAM") = SUM((S,G), ASAM(S,G));
TRACE("MAKE","DATA") = SUM((SJ,GJ), MAKE(SJ,GJ));

PUTCLOSE 'Aggregating USE'/;
$batinclude mapn asam use mapg maps
TRACE("USE","SAM") = SUM((S,G), ASAM(G,S));
TRACE("USE","DATA") = SUM((SJ,GJ), USE(GJ,SJ));

PUTCLOSE /,'Aggregating IUSE'/;
$batinclude mapn asam iuse mapg mapi
TRACE("IUSE","SAM") = SUM((G,I), ASAM(G,I));
TRACE("IUSE","DATA") = SUM((GJ,IJ), IUSE(GJ,IJ));

PUTCLOSE 'Aggregating FD'/;
$batinclude mapn asam fd mapf maps
TRACE("FD","SAM") = SUM((F,S), ASAM(F,S));
TRACE("FD","DATA") = SUM((FJ,SJ), FD(FJ,SJ));

PUTCLOSE 'Aggregating FEXPRT'/;
$batinclude mapn asam fexprt mapf mapt
TRACE("FEXPRT","SAM") = SUM((F,TRD), ASAM(F,TRD));
TRACE("FEXPRT","DATA") = SUM((FJ,TJ), FEXPRT(FJ,TJ));

PUTCLOSE 'Aggregating IMAKE'/;
$batinclude mapn asam imake mapi mapg
TRACE("IMAKE","SAM") = SUM((I,G), ASAM(I,G));
TRACE("IMAKE","DATA") = SUM((IJ,GJ), IMAKE(IJ,GJ));

PUTCLOSE 'Aggregating FS'/;
$batinclude mapn asam fs mapi mapf
TRACE("FS","SAM") = SUM((I,F), ASAM(I,F));
TRACE("FS","DATA") = SUM((IJ,FJ), FS(IJ,FJ));

PUTCLOSE 'Aggregating TRNSFER'/;
$batinclude mapn asam trnsfer mapi mapii
TRACE("TRNSFER","SAM") = SUM((I,II), ASAM(I,II));
TRACE("TRNSFER","DATA") = SUM((IJ,IIJ),TRNSFER(IJ,IIJ));

PUTCLOSE 'Aggregating FIMPRT'/;
$batinclude mapn asam fimprt mapt mapf
TRACE("FIMPRT","SAM") = SUM((TRD,F), ASAM(TRD,F));
TRACE("FIMPRT","DATA") = SUM((TJ,FJ), FIMPRT(TJ,FJ));

PUTCLOSE 'Aggregating TRNSHP'/;
$batinclude mapn asam trnshp mapt maptt
TRACE("TRNSHP","SAM") = SUM((TRD,TTRD), ASAM(TRD,TTRD));
TRACE("TRNSHP","DATA") = SUM((TJ,TTJ), TRNSHP(TJ,TTJ));

PARAMETER OTHERX(j,*,*), OTHERM(*,*,j);

PUTCLOSE 'Aggregating EXPORT'/;
set mapis(*,j);
mapis(s,j) = maps(s,j);
mapis(i,j) = mapi(i,j);
$batinclude mapn sam export mapis mapg mapt

set tnotg(*); tnotg(t) = yes; tnotg(g) = no;
$batinclude mapn sam otherx mapis tnotg mapt
$batinclude mapn sam otherm mapt tnotg mapis

PUTCLOSE 'Aggregating IMPORT'/;

$batinclude mapn sam import mapt mapg mapis

PUTCLOSE 'Aggregating SEXPRT/SIMPRT'/;
$batinclude mapn asam sexprt maps mapt
TRACE("SEXPRT","SAM")  = SUM((S,TRD), ASAM(S,TRD));
TRACE("SEXPRT","DATA") = SUM((SJ,TJ), SEXPRT(SJ,TJ));

$batinclude mapn asam simprt mapt maps 
SIMPRT(TJ,SJ) = SUM((S,TRD)$(MAP(SJ,S) AND MAP(TJ,TRD)), ASAM(TRD,S));
TRACE("SIMPRT","SAM")  = SUM((S,TRD), ASAM(TRD,S));
TRACE("SIMPRT","DATA") = SUM((SJ,TJ), SIMPRT(TJ,SJ));


PUTCLOSE 'Aggregating IEXPRT/IIMPRT'/;
$batinclude mapn asam iexprt mapi mapt
TRACE("IEXPRT","SAM")  = SUM((I,TRD), ASAM(I,TRD));
TRACE("IEXPRT","DATA") = SUM((IJ,TJ), IEXPRT(IJ,TJ));

$batinclude mapn asam iimprt mapt mapi
TRACE("IIMPRT","SAM")  = SUM((I,TRD), ASAM(TRD,I));
TRACE("IIMPRT","DATA") = SUM((IJ,TJ), IIMPRT(TJ,IJ));

$offuni

*       Suppress sector and goods names for vacuous entries:

SET     DROPS(J)        Sectors which are not used,
        DROPG(J)        Goods which are not used;

set mkt/FTRD,DTRD/;

DROPS(J)$SJ(J) = YES$(SUM(GJ,MAKE(J,GJ))+SUM(TJ,SEXPRT(J,TJ)) EQ 0);

DROPG(J)$GJ(J) = YES$(SUM(SJ,MAKE(SJ,J) +SUM(MKT,EXPORT(SJ,J,MKT)))
		     +SUM(IJ,IMAKE(IJ,J)+SUM(MKT,EXPORT(IJ,J,MKT)))
		     +SUM((JJ,TJ),IMPORT(TJ,J,JJ)) EQ 0);
DISPLAY DROPS, DROPG;

SJ(J)$DROPS(J) = NO;
GJ(J)$DROPG(J) = NO;
SJ(J)$GJ(J) = YES;

TRACE("TOTAL","DATA") =
        SUM((J,JJ),     MAKE(J,JJ) + SEXPRT(J,JJ) + USE(J,JJ) + IUSE(J,JJ) +
                        FD(J,JJ) + FEXPRT(J,JJ) + IMAKE(J,JJ) + FS(J,JJ) +
                        TRNSFER(J,JJ) + IEXPRT(J,JJ) + SIMPRT(J,JJ) +
                        FIMPRT(J,JJ) + IIMPRT(J,JJ) + TRNSHP(J,JJ));

TRACE("TOTAL","SAM") = ASUM;

PARAMETER TRADE  Cross check of sectoral- and commodity-level trade flows;

TRADE("EXPORT","DATA") = SUM((J,GJ,TJ), EXPORT(J,GJ,TJ));
TRADE("EXPORT","SAM")  = SUM((J,JJ), SEXPRT(J,JJ)+IEXPRT(J,JJ));

TRADE("IMPORT","DATA") = SUM((J,GJ,TJ), IMPORT(TJ,GJ,J));
TRADE("IMPORT","SAM")  = SUM((J,JJ), SIMPRT(J,JJ)+IIMPRT(J,JJ));

DISPLAY TRADE;

SET DATAELE /	MAKE,USE,IUSE,FD,FEXPRT,IMAKE,FS,TRNSFER,
		FIMPRT,TRNSHP,SEXPRT,IEXPRT,SIMPRT,IIMPRT/;

TRACE(DATAELE,"DIFF") = ROUND(TRACE(DATAELE,"SAM") - TRACE(DATAELE,"DATA"),2);
DISPLAY TRACE;

*	Write out the data to a temporary GDX file:

PUTCLOSE 'Writing data\%ds%.gdx'/;
$call 'if not exist data\nul mkdir data'
execute_unload 'temp.gdx',sj=s,fj=f,tj=trd,ij=i,make,sexprt,use,iuse,fd,
   fexprt,imake,fs,trnsfer,iexprt,simprt,fimprt,iimprt,trnshp,export,import;
